"use strict";(self["webpackChunkdpgui"]=self["webpackChunkdpgui"]||[]).push([[918],{4528:function(e){e.exports=JSON.parse('[{"object":"Argument","name":"model","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"type_map":{"object":"Argument","name":"type_map","type":["list"],"optional":true,"alias":[],"doc":"A list of strings. Give the name to each type of atoms. It is noted that the number of atom type of training system must be less than 128 in a GPU environment. If not given, type.raw in each system should use the same type indexes, and type_map.raw will take no effect.","repeat":false,"sub_fields":{},"sub_variants":{}},"data_stat_nbatch":{"object":"Argument","name":"data_stat_nbatch","type":["int"],"optional":true,"alias":[],"doc":"The model determines the normalization from the statistics of the data. This key specifies the number of `frames` in each `system` used for statistics.","repeat":false,"sub_fields":{},"sub_variants":{},"default":10},"data_stat_protect":{"object":"Argument","name":"data_stat_protect","type":["float"],"optional":true,"alias":[],"doc":"Protect parameter for atomic energy regression.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.01},"data_bias_nsample":{"object":"Argument","name":"data_bias_nsample","type":["int"],"optional":true,"alias":[],"doc":"The number of training samples in a system to compute and change the energy bias.","repeat":false,"sub_fields":{},"sub_variants":{},"default":10},"use_srtab":{"object":"Argument","name":"use_srtab","type":["str"],"optional":true,"alias":[],"doc":"The table for the short-range pairwise interaction added on top of DP. The table is a text data file with (N_t + 1) * N_t / 2 + 1 columes. The first colume is the distance between atoms. The second to the last columes are energies for pairs of certain types. For example we have two atom types, 0 and 1. The columes from 2nd to 4th are for 0-0, 0-1 and 1-1 correspondingly.","repeat":false,"sub_fields":{},"sub_variants":{}},"smin_alpha":{"object":"Argument","name":"smin_alpha","type":["float"],"optional":true,"alias":[],"doc":"The short-range tabulated interaction will be swithed according to the distance of the nearest neighbor. This distance is calculated by softmin. This parameter is the decaying parameter in the softmin. It is only required when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{}},"sw_rmin":{"object":"Argument","name":"sw_rmin","type":["float"],"optional":true,"alias":[],"doc":"The lower boundary of the interpolation between short-range tabulated interaction and DP. It is only required when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{}},"sw_rmax":{"object":"Argument","name":"sw_rmax","type":["float"],"optional":true,"alias":[],"doc":"The upper boundary of the interpolation between short-range tabulated interaction and DP. It is only required when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{}},"srtab_add_bias":{"object":"Argument","name":"srtab_add_bias","type":["bool"],"optional":true,"alias":[],"doc":"Whether add energy bias from the statistics of the data to short-range tabulated atomic energy. It only takes effect when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"type_embedding":{"object":"Argument","name":"type_embedding","type":["dict"],"optional":true,"alias":[],"doc":"The type embedding.","repeat":false,"sub_fields":{"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[8]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{},"default":null}},"sub_variants":{}},"modifier":{"object":"Argument","name":"modifier","type":["dict"],"optional":true,"alias":[],"doc":"The modifier of model output.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"dipole_charge":{"object":"Argument","name":"dipole_charge","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"model_name":{"object":"Argument","name":"model_name","type":["str"],"optional":false,"alias":[],"doc":"The name of the frozen dipole model file.","repeat":false,"sub_fields":{},"sub_variants":{}},"model_charge_map":{"object":"Argument","name":"model_charge_map","type":["list"],"optional":false,"alias":[],"doc":"The charge of the WFCC. The list length should be the same as the `sel_type <model/fitting_net[dipole]/sel_type_>`_. ","repeat":false,"sub_fields":{},"sub_variants":{}},"sys_charge_map":{"object":"Argument","name":"sys_charge_map","type":["list"],"optional":false,"alias":[],"doc":"The charge of real atoms. The list length should be the same as the `type_map <model/type_map_>`_","repeat":false,"sub_fields":{},"sub_variants":{}},"ewald_beta":{"object":"Argument","name":"ewald_beta","type":["float"],"optional":true,"alias":[],"doc":"The splitting parameter of Ewald sum. Unit is A^-1","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.4},"ewald_h":{"object":"Argument","name":"ewald_h","type":["float"],"optional":true,"alias":[],"doc":"The grid spacing of the FFT grid. Unit is A","repeat":false,"sub_fields":{},"sub_variants":{},"default":1}},"sub_variants":{}}},"choice_alias":{},"doc":"The type of modifier. See explanation below.\\n\\n-`dipole_charge`: Use WFCC to model the electronic structure of the system. Correct the long-range interaction"}}},"compress":{"object":"Argument","name":"compress","type":["dict"],"optional":true,"alias":[],"doc":"Model compression configurations","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":true,"default_tag":"se_e2_a","choice_dict":{"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"model_file":{"object":"Argument","name":"model_file","type":["str"],"optional":false,"alias":[],"doc":"The input model file, which will be compressed by the DeePMD-kit.","repeat":false,"sub_fields":{},"sub_variants":{}},"table_config":{"object":"Argument","name":"table_config","type":["list"],"optional":false,"alias":[],"doc":"The arguments of model compression, including extrapolate(scale of model extrapolation), stride(uniform stride of tabulation\'s first and second table), and frequency(frequency of tabulation overflow check).","repeat":false,"sub_fields":{},"sub_variants":{}},"min_nbor_dist":{"object":"Argument","name":"min_nbor_dist","type":["float"],"optional":false,"alias":[],"doc":"The nearest distance between neighbor atoms saved in the frozen model.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a"},"doc":"The type of model compression, which should be consistent with the descriptor type."}}},"spin":{"object":"Argument","name":"spin","type":["dict"],"optional":true,"alias":[],"doc":"The settings for systems with spin.","repeat":false,"sub_fields":{"use_spin":{"object":"Argument","name":"use_spin","type":["list"],"optional":false,"alias":[],"doc":"Whether to use atomic spin model for each atom type","repeat":false,"sub_fields":{},"sub_variants":{}},"spin_norm":{"object":"Argument","name":"spin_norm","type":["list"],"optional":false,"alias":[],"doc":"The magnitude of atomic spin for each atom type with spin","repeat":false,"sub_fields":{},"sub_variants":{}},"virtual_len":{"object":"Argument","name":"virtual_len","type":["list"],"optional":false,"alias":[],"doc":"The distance between virtual atom representing spin and its corresponding real atom for each atom type with spin","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":true,"default_tag":"standard","choice_dict":{"standard":{"object":"Argument","name":"standard","type":["dict"],"optional":false,"alias":[],"doc":"Stardard model, which contains a descriptor and a fitting.","repeat":false,"sub_fields":{"descriptor":{"object":"Argument","name":"descriptor","type":["dict"],"optional":false,"alias":[],"doc":"The descriptor of atomic environment.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"hybrid":{"object":"Argument","name":"hybrid","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"list":{"object":"Argument","name":"list","type":["list"],"optional":false,"alias":[],"doc":"A list of descriptor definitions","repeat":true,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}},"fitting_net":{"object":"Argument","name":"fitting_net","type":["dict"],"optional":false,"alias":[],"doc":"The fitting of physical properties.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":true,"default_tag":"ener","choice_dict":{"ener":{"object":"Argument","name":"ener","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"numb_fparam":{"object":"Argument","name":"numb_fparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the frame parameter. If set to >0, file `fparam.npy` should be included to provided the input fparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the atomic parameter. If set to >0, file `aparam.npy` should be included to provided the input aparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":["n_neuron"],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"trainable":{"object":"Argument","name":"trainable","type":["list","bool"],"optional":true,"alias":[],"doc":"Whether the parameters in the fitting net are trainable. This option can be\\n\\n- bool: True if all parameters of the fitting net are trainable, False otherwise.\\n\\n- list of bool: Specifies if each layer is trainable. Since the fitting net is composed by hidden layers followed by a output layer, the length of tihs list should be equal to len(`neuron`)+1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"rcond":{"object":"Argument","name":"rcond","type":["NoneType","float"],"optional":true,"alias":[],"doc":"The condition number used to determine the inital energy shift for each type of atoms. See `rcond` in :py:meth:`numpy.linalg.lstsq` for more details.","repeat":false,"sub_fields":{},"sub_variants":{},"default":null},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}},"atom_ener":{"object":"Argument","name":"atom_ener","type":["list"],"optional":true,"alias":[],"doc":"Specify the atomic energy in vacuum for each type","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"layer_name":{"object":"Argument","name":"layer_name","type":["list"],"optional":true,"alias":[],"doc":"The name of the each layer. The length of this list should be equal to n_neuron + 1. If two layers, either in the same fitting or different fittings, have the same name, they will share the same neural network parameters. The shape of these layers should be the same. If null is given for a layer, parameters will not be shared.","repeat":false,"sub_fields":{},"sub_variants":{}},"use_aparam_as_mask":{"object":"Argument","name":"use_aparam_as_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use the aparam as a mask in input.If True, the aparam will not be used in fitting net for embedding.When descrpt is se_a_mask, the aparam will be used as a mask to indicate the input atom is real/virtual. And use_aparam_as_mask should be set to True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"dos":{"object":"Argument","name":"dos","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"numb_fparam":{"object":"Argument","name":"numb_fparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the frame parameter. If set to >0, file `fparam.npy` should be included to provided the input fparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the atomic parameter. If set to >0, file `aparam.npy` should be included to provided the input aparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"float64"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"trainable":{"object":"Argument","name":"trainable","type":["list","bool"],"optional":true,"alias":[],"doc":"Whether the parameters in the fitting net are trainable. This option can be\\n\\n- bool: True if all parameters of the fitting net are trainable, False otherwise.\\n\\n- list of bool: Specifies if each layer is trainable. Since the fitting net is composed by hidden layers followed by a output layer, the length of tihs list should be equal to len(`neuron`)+1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"rcond":{"object":"Argument","name":"rcond","type":["NoneType","float"],"optional":true,"alias":[],"doc":"The condition number used to determine the inital energy shift for each type of atoms. See `rcond` in :py:meth:`numpy.linalg.lstsq` for more details.","repeat":false,"sub_fields":{},"sub_variants":{},"default":null},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}},"numb_dos":{"object":"Argument","name":"numb_dos","type":["int"],"optional":true,"alias":[],"doc":"The number of gridpoints on which the DOS is evaluated (NEDOS in VASP)","repeat":false,"sub_fields":{},"sub_variants":{},"default":300}},"sub_variants":{}},"polar":{"object":"Argument","name":"polar","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":["n_neuron"],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"fit_diag":{"object":"Argument","name":"fit_diag","type":["bool"],"optional":true,"alias":[],"doc":"Fit the diagonal part of the rotational invariant polarizability matrix, which will be converted to normal polarizability matrix by contracting with the rotation matrix.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"scale":{"object":"Argument","name":"scale","type":["list","float"],"optional":true,"alias":[],"doc":"The output of the fitting net (polarizability matrix) will be scaled by ``scale``","repeat":false,"sub_fields":{},"sub_variants":{},"default":1},"shift_diag":{"object":"Argument","name":"shift_diag","type":["bool"],"optional":true,"alias":[],"doc":"Whether to shift the diagonal of polar, which is beneficial to training. Default is true.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"sel_type":{"object":"Argument","name":"sel_type","type":["list","int","NoneType"],"optional":true,"alias":["pol_type"],"doc":"The atom types for which the atomic polarizability will be provided. If not set, all types will be selected.","repeat":false,"sub_fields":{},"sub_variants":{}},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"dipole":{"object":"Argument","name":"dipole","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":["n_neuron"],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"sel_type":{"object":"Argument","name":"sel_type","type":["list","int","NoneType"],"optional":true,"alias":["dipole_type"],"doc":"The atom types for which the atomic dipole will be provided. If not set, all types will be selected.","repeat":false,"sub_fields":{},"sub_variants":{}},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{},"doc":"The type of the fitting. See explanation below. \\n\\n- `ener`: Fit an energy model (potential energy surface).\\n\\n- `dos` : Fit a density of states model. The total density of states / site-projected density of states labels should be provided by `dos.npy` or `atom_dos.npy` in each data system. The file has number of frames lines and number of energy grid columns (times number of atoms in `atom_dos.npy`). See `loss` parameter. \\n\\n- `dipole`: Fit an atomic dipole model. Global dipole labels or atomic dipole labels for all the selected atoms (see `sel_type`) should be provided by `dipole.npy` in each data system. The file either has number of frames lines and 3 times of number of selected atoms columns, or has number of frames lines and 3 columns. See `loss` parameter.\\n\\n- `polar`: Fit an atomic polarizability model. Global polarizazbility labels or atomic polarizability labels for all the selected atoms (see `sel_type`) should be provided by `polarizability.npy` in each data system. The file eith has number of frames lines and 9 times of number of selected atoms columns, or has number of frames lines and 9 columns. See `loss` parameter.\\n\\n"}}}},"sub_variants":{}},"multi":{"object":"Argument","name":"multi","type":["dict"],"optional":false,"alias":[],"doc":"Multiple-task model.","repeat":false,"sub_fields":{"descriptor":{"object":"Argument","name":"descriptor","type":["dict"],"optional":false,"alias":[],"doc":"The descriptor of atomic environment. See model[standard]/descriptor for details.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"hybrid":{"object":"Argument","name":"hybrid","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"list":{"object":"Argument","name":"list","type":["list"],"optional":false,"alias":[],"doc":"A list of descriptor definitions","repeat":true,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}},"fitting_net_dict":{"object":"Argument","name":"fitting_net_dict","type":["dict"],"optional":false,"alias":[],"doc":"The dictionary of multiple fitting nets in multi-task mode. Each fitting_net_dict[fitting_key] is the single definition of fitting of physical properties with user-defined name `fitting_key`.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"frozen":{"object":"Argument","name":"frozen","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"model_file":{"object":"Argument","name":"model_file","type":["str"],"optional":false,"alias":[],"doc":"Path to the frozen model file.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"pairwise_dprc":{"object":"Argument","name":"pairwise_dprc","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"qm_model":{"object":"Argument","name":"qm_model","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"type_map":{"object":"Argument","name":"type_map","type":["list"],"optional":true,"alias":[],"doc":"A list of strings. Give the name to each type of atoms. It is noted that the number of atom type of training system must be less than 128 in a GPU environment. If not given, type.raw in each system should use the same type indexes, and type_map.raw will take no effect.","repeat":false,"sub_fields":{},"sub_variants":{}},"data_stat_nbatch":{"object":"Argument","name":"data_stat_nbatch","type":["int"],"optional":true,"alias":[],"doc":"The model determines the normalization from the statistics of the data. This key specifies the number of `frames` in each `system` used for statistics.","repeat":false,"sub_fields":{},"sub_variants":{},"default":10},"data_stat_protect":{"object":"Argument","name":"data_stat_protect","type":["float"],"optional":true,"alias":[],"doc":"Protect parameter for atomic energy regression.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.01},"data_bias_nsample":{"object":"Argument","name":"data_bias_nsample","type":["int"],"optional":true,"alias":[],"doc":"The number of training samples in a system to compute and change the energy bias.","repeat":false,"sub_fields":{},"sub_variants":{},"default":10},"use_srtab":{"object":"Argument","name":"use_srtab","type":["str"],"optional":true,"alias":[],"doc":"The table for the short-range pairwise interaction added on top of DP. The table is a text data file with (N_t + 1) * N_t / 2 + 1 columes. The first colume is the distance between atoms. The second to the last columes are energies for pairs of certain types. For example we have two atom types, 0 and 1. The columes from 2nd to 4th are for 0-0, 0-1 and 1-1 correspondingly.","repeat":false,"sub_fields":{},"sub_variants":{}},"smin_alpha":{"object":"Argument","name":"smin_alpha","type":["float"],"optional":true,"alias":[],"doc":"The short-range tabulated interaction will be swithed according to the distance of the nearest neighbor. This distance is calculated by softmin. This parameter is the decaying parameter in the softmin. It is only required when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{}},"sw_rmin":{"object":"Argument","name":"sw_rmin","type":["float"],"optional":true,"alias":[],"doc":"The lower boundary of the interpolation between short-range tabulated interaction and DP. It is only required when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{}},"sw_rmax":{"object":"Argument","name":"sw_rmax","type":["float"],"optional":true,"alias":[],"doc":"The upper boundary of the interpolation between short-range tabulated interaction and DP. It is only required when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{}},"srtab_add_bias":{"object":"Argument","name":"srtab_add_bias","type":["bool"],"optional":true,"alias":[],"doc":"Whether add energy bias from the statistics of the data to short-range tabulated atomic energy. It only takes effect when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"type_embedding":{"object":"Argument","name":"type_embedding","type":["dict"],"optional":true,"alias":[],"doc":"The type embedding.","repeat":false,"sub_fields":{"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[8]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{},"default":null}},"sub_variants":{}},"modifier":{"object":"Argument","name":"modifier","type":["dict"],"optional":true,"alias":[],"doc":"The modifier of model output.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"dipole_charge":{"object":"Argument","name":"dipole_charge","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"model_name":{"object":"Argument","name":"model_name","type":["str"],"optional":false,"alias":[],"doc":"The name of the frozen dipole model file.","repeat":false,"sub_fields":{},"sub_variants":{}},"model_charge_map":{"object":"Argument","name":"model_charge_map","type":["list"],"optional":false,"alias":[],"doc":"The charge of the WFCC. The list length should be the same as the `sel_type <model/fitting_net[dipole]/sel_type_>`_. ","repeat":false,"sub_fields":{},"sub_variants":{}},"sys_charge_map":{"object":"Argument","name":"sys_charge_map","type":["list"],"optional":false,"alias":[],"doc":"The charge of real atoms. The list length should be the same as the `type_map <model/type_map_>`_","repeat":false,"sub_fields":{},"sub_variants":{}},"ewald_beta":{"object":"Argument","name":"ewald_beta","type":["float"],"optional":true,"alias":[],"doc":"The splitting parameter of Ewald sum. Unit is A^-1","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.4},"ewald_h":{"object":"Argument","name":"ewald_h","type":["float"],"optional":true,"alias":[],"doc":"The grid spacing of the FFT grid. Unit is A","repeat":false,"sub_fields":{},"sub_variants":{},"default":1}},"sub_variants":{}}},"choice_alias":{},"doc":"The type of modifier. See explanation below.\\n\\n-`dipole_charge`: Use WFCC to model the electronic structure of the system. Correct the long-range interaction"}}},"compress":{"object":"Argument","name":"compress","type":["dict"],"optional":true,"alias":[],"doc":"Model compression configurations","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":true,"default_tag":"se_e2_a","choice_dict":{"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"model_file":{"object":"Argument","name":"model_file","type":["str"],"optional":false,"alias":[],"doc":"The input model file, which will be compressed by the DeePMD-kit.","repeat":false,"sub_fields":{},"sub_variants":{}},"table_config":{"object":"Argument","name":"table_config","type":["list"],"optional":false,"alias":[],"doc":"The arguments of model compression, including extrapolate(scale of model extrapolation), stride(uniform stride of tabulation\'s first and second table), and frequency(frequency of tabulation overflow check).","repeat":false,"sub_fields":{},"sub_variants":{}},"min_nbor_dist":{"object":"Argument","name":"min_nbor_dist","type":["float"],"optional":false,"alias":[],"doc":"The nearest distance between neighbor atoms saved in the frozen model.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a"},"doc":"The type of model compression, which should be consistent with the descriptor type."}}},"spin":{"object":"Argument","name":"spin","type":["dict"],"optional":true,"alias":[],"doc":"The settings for systems with spin.","repeat":false,"sub_fields":{"use_spin":{"object":"Argument","name":"use_spin","type":["list"],"optional":false,"alias":[],"doc":"Whether to use atomic spin model for each atom type","repeat":false,"sub_fields":{},"sub_variants":{}},"spin_norm":{"object":"Argument","name":"spin_norm","type":["list"],"optional":false,"alias":[],"doc":"The magnitude of atomic spin for each atom type with spin","repeat":false,"sub_fields":{},"sub_variants":{}},"virtual_len":{"object":"Argument","name":"virtual_len","type":["list"],"optional":false,"alias":[],"doc":"The distance between virtual atom representing spin and its corresponding real atom for each atom type with spin","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":true,"default_tag":"standard","choice_dict":{"standard":{"object":"Argument","name":"standard","type":["dict"],"optional":false,"alias":[],"doc":"Stardard model, which contains a descriptor and a fitting.","repeat":false,"sub_fields":{"descriptor":{"object":"Argument","name":"descriptor","type":["dict"],"optional":false,"alias":[],"doc":"The descriptor of atomic environment.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"hybrid":{"object":"Argument","name":"hybrid","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"list":{"object":"Argument","name":"list","type":["list"],"optional":false,"alias":[],"doc":"A list of descriptor definitions","repeat":true,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}},"fitting_net":{"object":"Argument","name":"fitting_net","type":["dict"],"optional":false,"alias":[],"doc":"The fitting of physical properties.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":true,"default_tag":"ener","choice_dict":{"ener":{"object":"Argument","name":"ener","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"numb_fparam":{"object":"Argument","name":"numb_fparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the frame parameter. If set to >0, file `fparam.npy` should be included to provided the input fparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the atomic parameter. If set to >0, file `aparam.npy` should be included to provided the input aparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":["n_neuron"],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"trainable":{"object":"Argument","name":"trainable","type":["list","bool"],"optional":true,"alias":[],"doc":"Whether the parameters in the fitting net are trainable. This option can be\\n\\n- bool: True if all parameters of the fitting net are trainable, False otherwise.\\n\\n- list of bool: Specifies if each layer is trainable. Since the fitting net is composed by hidden layers followed by a output layer, the length of tihs list should be equal to len(`neuron`)+1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"rcond":{"object":"Argument","name":"rcond","type":["NoneType","float"],"optional":true,"alias":[],"doc":"The condition number used to determine the inital energy shift for each type of atoms. See `rcond` in :py:meth:`numpy.linalg.lstsq` for more details.","repeat":false,"sub_fields":{},"sub_variants":{},"default":null},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}},"atom_ener":{"object":"Argument","name":"atom_ener","type":["list"],"optional":true,"alias":[],"doc":"Specify the atomic energy in vacuum for each type","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"layer_name":{"object":"Argument","name":"layer_name","type":["list"],"optional":true,"alias":[],"doc":"The name of the each layer. The length of this list should be equal to n_neuron + 1. If two layers, either in the same fitting or different fittings, have the same name, they will share the same neural network parameters. The shape of these layers should be the same. If null is given for a layer, parameters will not be shared.","repeat":false,"sub_fields":{},"sub_variants":{}},"use_aparam_as_mask":{"object":"Argument","name":"use_aparam_as_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use the aparam as a mask in input.If True, the aparam will not be used in fitting net for embedding.When descrpt is se_a_mask, the aparam will be used as a mask to indicate the input atom is real/virtual. And use_aparam_as_mask should be set to True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"dos":{"object":"Argument","name":"dos","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"numb_fparam":{"object":"Argument","name":"numb_fparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the frame parameter. If set to >0, file `fparam.npy` should be included to provided the input fparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the atomic parameter. If set to >0, file `aparam.npy` should be included to provided the input aparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"float64"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"trainable":{"object":"Argument","name":"trainable","type":["list","bool"],"optional":true,"alias":[],"doc":"Whether the parameters in the fitting net are trainable. This option can be\\n\\n- bool: True if all parameters of the fitting net are trainable, False otherwise.\\n\\n- list of bool: Specifies if each layer is trainable. Since the fitting net is composed by hidden layers followed by a output layer, the length of tihs list should be equal to len(`neuron`)+1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"rcond":{"object":"Argument","name":"rcond","type":["NoneType","float"],"optional":true,"alias":[],"doc":"The condition number used to determine the inital energy shift for each type of atoms. See `rcond` in :py:meth:`numpy.linalg.lstsq` for more details.","repeat":false,"sub_fields":{},"sub_variants":{},"default":null},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}},"numb_dos":{"object":"Argument","name":"numb_dos","type":["int"],"optional":true,"alias":[],"doc":"The number of gridpoints on which the DOS is evaluated (NEDOS in VASP)","repeat":false,"sub_fields":{},"sub_variants":{},"default":300}},"sub_variants":{}},"polar":{"object":"Argument","name":"polar","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":["n_neuron"],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"fit_diag":{"object":"Argument","name":"fit_diag","type":["bool"],"optional":true,"alias":[],"doc":"Fit the diagonal part of the rotational invariant polarizability matrix, which will be converted to normal polarizability matrix by contracting with the rotation matrix.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"scale":{"object":"Argument","name":"scale","type":["list","float"],"optional":true,"alias":[],"doc":"The output of the fitting net (polarizability matrix) will be scaled by ``scale``","repeat":false,"sub_fields":{},"sub_variants":{},"default":1},"shift_diag":{"object":"Argument","name":"shift_diag","type":["bool"],"optional":true,"alias":[],"doc":"Whether to shift the diagonal of polar, which is beneficial to training. Default is true.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"sel_type":{"object":"Argument","name":"sel_type","type":["list","int","NoneType"],"optional":true,"alias":["pol_type"],"doc":"The atom types for which the atomic polarizability will be provided. If not set, all types will be selected.","repeat":false,"sub_fields":{},"sub_variants":{}},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"dipole":{"object":"Argument","name":"dipole","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":["n_neuron"],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"sel_type":{"object":"Argument","name":"sel_type","type":["list","int","NoneType"],"optional":true,"alias":["dipole_type"],"doc":"The atom types for which the atomic dipole will be provided. If not set, all types will be selected.","repeat":false,"sub_fields":{},"sub_variants":{}},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{},"doc":"The type of the fitting. See explanation below. \\n\\n- `ener`: Fit an energy model (potential energy surface).\\n\\n- `dos` : Fit a density of states model. The total density of states / site-projected density of states labels should be provided by `dos.npy` or `atom_dos.npy` in each data system. The file has number of frames lines and number of energy grid columns (times number of atoms in `atom_dos.npy`). See `loss` parameter. \\n\\n- `dipole`: Fit an atomic dipole model. Global dipole labels or atomic dipole labels for all the selected atoms (see `sel_type`) should be provided by `dipole.npy` in each data system. The file either has number of frames lines and 3 times of number of selected atoms columns, or has number of frames lines and 3 columns. See `loss` parameter.\\n\\n- `polar`: Fit an atomic polarizability model. Global polarizazbility labels or atomic polarizability labels for all the selected atoms (see `sel_type`) should be provided by `polarizability.npy` in each data system. The file eith has number of frames lines and 9 times of number of selected atoms columns, or has number of frames lines and 9 columns. See `loss` parameter.\\n\\n"}}}},"sub_variants":{}},"multi":{"object":"Argument","name":"multi","type":["dict"],"optional":false,"alias":[],"doc":"Multiple-task model.","repeat":false,"sub_fields":{"descriptor":{"object":"Argument","name":"descriptor","type":["dict"],"optional":false,"alias":[],"doc":"The descriptor of atomic environment. See model[standard]/descriptor for details.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"hybrid":{"object":"Argument","name":"hybrid","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"list":{"object":"Argument","name":"list","type":["list"],"optional":false,"alias":[],"doc":"A list of descriptor definitions","repeat":true,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}},"fitting_net_dict":{"object":"Argument","name":"fitting_net_dict","type":["dict"],"optional":false,"alias":[],"doc":"The dictionary of multiple fitting nets in multi-task mode. Each fitting_net_dict[fitting_key] is the single definition of fitting of physical properties with user-defined name `fitting_key`.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"frozen":{"object":"Argument","name":"frozen","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"model_file":{"object":"Argument","name":"model_file","type":["str"],"optional":false,"alias":[],"doc":"Path to the frozen model file.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{},"doc":""}}},"qmmm_model":{"object":"Argument","name":"qmmm_model","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"type_map":{"object":"Argument","name":"type_map","type":["list"],"optional":true,"alias":[],"doc":"A list of strings. Give the name to each type of atoms. It is noted that the number of atom type of training system must be less than 128 in a GPU environment. If not given, type.raw in each system should use the same type indexes, and type_map.raw will take no effect.","repeat":false,"sub_fields":{},"sub_variants":{}},"data_stat_nbatch":{"object":"Argument","name":"data_stat_nbatch","type":["int"],"optional":true,"alias":[],"doc":"The model determines the normalization from the statistics of the data. This key specifies the number of `frames` in each `system` used for statistics.","repeat":false,"sub_fields":{},"sub_variants":{},"default":10},"data_stat_protect":{"object":"Argument","name":"data_stat_protect","type":["float"],"optional":true,"alias":[],"doc":"Protect parameter for atomic energy regression.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.01},"data_bias_nsample":{"object":"Argument","name":"data_bias_nsample","type":["int"],"optional":true,"alias":[],"doc":"The number of training samples in a system to compute and change the energy bias.","repeat":false,"sub_fields":{},"sub_variants":{},"default":10},"use_srtab":{"object":"Argument","name":"use_srtab","type":["str"],"optional":true,"alias":[],"doc":"The table for the short-range pairwise interaction added on top of DP. The table is a text data file with (N_t + 1) * N_t / 2 + 1 columes. The first colume is the distance between atoms. The second to the last columes are energies for pairs of certain types. For example we have two atom types, 0 and 1. The columes from 2nd to 4th are for 0-0, 0-1 and 1-1 correspondingly.","repeat":false,"sub_fields":{},"sub_variants":{}},"smin_alpha":{"object":"Argument","name":"smin_alpha","type":["float"],"optional":true,"alias":[],"doc":"The short-range tabulated interaction will be swithed according to the distance of the nearest neighbor. This distance is calculated by softmin. This parameter is the decaying parameter in the softmin. It is only required when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{}},"sw_rmin":{"object":"Argument","name":"sw_rmin","type":["float"],"optional":true,"alias":[],"doc":"The lower boundary of the interpolation between short-range tabulated interaction and DP. It is only required when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{}},"sw_rmax":{"object":"Argument","name":"sw_rmax","type":["float"],"optional":true,"alias":[],"doc":"The upper boundary of the interpolation between short-range tabulated interaction and DP. It is only required when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{}},"srtab_add_bias":{"object":"Argument","name":"srtab_add_bias","type":["bool"],"optional":true,"alias":[],"doc":"Whether add energy bias from the statistics of the data to short-range tabulated atomic energy. It only takes effect when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"type_embedding":{"object":"Argument","name":"type_embedding","type":["dict"],"optional":true,"alias":[],"doc":"The type embedding.","repeat":false,"sub_fields":{"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[8]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{},"default":null}},"sub_variants":{}},"modifier":{"object":"Argument","name":"modifier","type":["dict"],"optional":true,"alias":[],"doc":"The modifier of model output.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"dipole_charge":{"object":"Argument","name":"dipole_charge","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"model_name":{"object":"Argument","name":"model_name","type":["str"],"optional":false,"alias":[],"doc":"The name of the frozen dipole model file.","repeat":false,"sub_fields":{},"sub_variants":{}},"model_charge_map":{"object":"Argument","name":"model_charge_map","type":["list"],"optional":false,"alias":[],"doc":"The charge of the WFCC. The list length should be the same as the `sel_type <model/fitting_net[dipole]/sel_type_>`_. ","repeat":false,"sub_fields":{},"sub_variants":{}},"sys_charge_map":{"object":"Argument","name":"sys_charge_map","type":["list"],"optional":false,"alias":[],"doc":"The charge of real atoms. The list length should be the same as the `type_map <model/type_map_>`_","repeat":false,"sub_fields":{},"sub_variants":{}},"ewald_beta":{"object":"Argument","name":"ewald_beta","type":["float"],"optional":true,"alias":[],"doc":"The splitting parameter of Ewald sum. Unit is A^-1","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.4},"ewald_h":{"object":"Argument","name":"ewald_h","type":["float"],"optional":true,"alias":[],"doc":"The grid spacing of the FFT grid. Unit is A","repeat":false,"sub_fields":{},"sub_variants":{},"default":1}},"sub_variants":{}}},"choice_alias":{},"doc":"The type of modifier. See explanation below.\\n\\n-`dipole_charge`: Use WFCC to model the electronic structure of the system. Correct the long-range interaction"}}},"compress":{"object":"Argument","name":"compress","type":["dict"],"optional":true,"alias":[],"doc":"Model compression configurations","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":true,"default_tag":"se_e2_a","choice_dict":{"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"model_file":{"object":"Argument","name":"model_file","type":["str"],"optional":false,"alias":[],"doc":"The input model file, which will be compressed by the DeePMD-kit.","repeat":false,"sub_fields":{},"sub_variants":{}},"table_config":{"object":"Argument","name":"table_config","type":["list"],"optional":false,"alias":[],"doc":"The arguments of model compression, including extrapolate(scale of model extrapolation), stride(uniform stride of tabulation\'s first and second table), and frequency(frequency of tabulation overflow check).","repeat":false,"sub_fields":{},"sub_variants":{}},"min_nbor_dist":{"object":"Argument","name":"min_nbor_dist","type":["float"],"optional":false,"alias":[],"doc":"The nearest distance between neighbor atoms saved in the frozen model.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a"},"doc":"The type of model compression, which should be consistent with the descriptor type."}}},"spin":{"object":"Argument","name":"spin","type":["dict"],"optional":true,"alias":[],"doc":"The settings for systems with spin.","repeat":false,"sub_fields":{"use_spin":{"object":"Argument","name":"use_spin","type":["list"],"optional":false,"alias":[],"doc":"Whether to use atomic spin model for each atom type","repeat":false,"sub_fields":{},"sub_variants":{}},"spin_norm":{"object":"Argument","name":"spin_norm","type":["list"],"optional":false,"alias":[],"doc":"The magnitude of atomic spin for each atom type with spin","repeat":false,"sub_fields":{},"sub_variants":{}},"virtual_len":{"object":"Argument","name":"virtual_len","type":["list"],"optional":false,"alias":[],"doc":"The distance between virtual atom representing spin and its corresponding real atom for each atom type with spin","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":true,"default_tag":"standard","choice_dict":{"standard":{"object":"Argument","name":"standard","type":["dict"],"optional":false,"alias":[],"doc":"Stardard model, which contains a descriptor and a fitting.","repeat":false,"sub_fields":{"descriptor":{"object":"Argument","name":"descriptor","type":["dict"],"optional":false,"alias":[],"doc":"The descriptor of atomic environment.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"hybrid":{"object":"Argument","name":"hybrid","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"list":{"object":"Argument","name":"list","type":["list"],"optional":false,"alias":[],"doc":"A list of descriptor definitions","repeat":true,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}},"fitting_net":{"object":"Argument","name":"fitting_net","type":["dict"],"optional":false,"alias":[],"doc":"The fitting of physical properties.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":true,"default_tag":"ener","choice_dict":{"ener":{"object":"Argument","name":"ener","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"numb_fparam":{"object":"Argument","name":"numb_fparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the frame parameter. If set to >0, file `fparam.npy` should be included to provided the input fparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the atomic parameter. If set to >0, file `aparam.npy` should be included to provided the input aparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":["n_neuron"],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"trainable":{"object":"Argument","name":"trainable","type":["list","bool"],"optional":true,"alias":[],"doc":"Whether the parameters in the fitting net are trainable. This option can be\\n\\n- bool: True if all parameters of the fitting net are trainable, False otherwise.\\n\\n- list of bool: Specifies if each layer is trainable. Since the fitting net is composed by hidden layers followed by a output layer, the length of tihs list should be equal to len(`neuron`)+1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"rcond":{"object":"Argument","name":"rcond","type":["NoneType","float"],"optional":true,"alias":[],"doc":"The condition number used to determine the inital energy shift for each type of atoms. See `rcond` in :py:meth:`numpy.linalg.lstsq` for more details.","repeat":false,"sub_fields":{},"sub_variants":{},"default":null},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}},"atom_ener":{"object":"Argument","name":"atom_ener","type":["list"],"optional":true,"alias":[],"doc":"Specify the atomic energy in vacuum for each type","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"layer_name":{"object":"Argument","name":"layer_name","type":["list"],"optional":true,"alias":[],"doc":"The name of the each layer. The length of this list should be equal to n_neuron + 1. If two layers, either in the same fitting or different fittings, have the same name, they will share the same neural network parameters. The shape of these layers should be the same. If null is given for a layer, parameters will not be shared.","repeat":false,"sub_fields":{},"sub_variants":{}},"use_aparam_as_mask":{"object":"Argument","name":"use_aparam_as_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use the aparam as a mask in input.If True, the aparam will not be used in fitting net for embedding.When descrpt is se_a_mask, the aparam will be used as a mask to indicate the input atom is real/virtual. And use_aparam_as_mask should be set to True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"dos":{"object":"Argument","name":"dos","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"numb_fparam":{"object":"Argument","name":"numb_fparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the frame parameter. If set to >0, file `fparam.npy` should be included to provided the input fparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the atomic parameter. If set to >0, file `aparam.npy` should be included to provided the input aparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"float64"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"trainable":{"object":"Argument","name":"trainable","type":["list","bool"],"optional":true,"alias":[],"doc":"Whether the parameters in the fitting net are trainable. This option can be\\n\\n- bool: True if all parameters of the fitting net are trainable, False otherwise.\\n\\n- list of bool: Specifies if each layer is trainable. Since the fitting net is composed by hidden layers followed by a output layer, the length of tihs list should be equal to len(`neuron`)+1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"rcond":{"object":"Argument","name":"rcond","type":["NoneType","float"],"optional":true,"alias":[],"doc":"The condition number used to determine the inital energy shift for each type of atoms. See `rcond` in :py:meth:`numpy.linalg.lstsq` for more details.","repeat":false,"sub_fields":{},"sub_variants":{},"default":null},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}},"numb_dos":{"object":"Argument","name":"numb_dos","type":["int"],"optional":true,"alias":[],"doc":"The number of gridpoints on which the DOS is evaluated (NEDOS in VASP)","repeat":false,"sub_fields":{},"sub_variants":{},"default":300}},"sub_variants":{}},"polar":{"object":"Argument","name":"polar","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":["n_neuron"],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"fit_diag":{"object":"Argument","name":"fit_diag","type":["bool"],"optional":true,"alias":[],"doc":"Fit the diagonal part of the rotational invariant polarizability matrix, which will be converted to normal polarizability matrix by contracting with the rotation matrix.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"scale":{"object":"Argument","name":"scale","type":["list","float"],"optional":true,"alias":[],"doc":"The output of the fitting net (polarizability matrix) will be scaled by ``scale``","repeat":false,"sub_fields":{},"sub_variants":{},"default":1},"shift_diag":{"object":"Argument","name":"shift_diag","type":["bool"],"optional":true,"alias":[],"doc":"Whether to shift the diagonal of polar, which is beneficial to training. Default is true.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"sel_type":{"object":"Argument","name":"sel_type","type":["list","int","NoneType"],"optional":true,"alias":["pol_type"],"doc":"The atom types for which the atomic polarizability will be provided. If not set, all types will be selected.","repeat":false,"sub_fields":{},"sub_variants":{}},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"dipole":{"object":"Argument","name":"dipole","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":["n_neuron"],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"sel_type":{"object":"Argument","name":"sel_type","type":["list","int","NoneType"],"optional":true,"alias":["dipole_type"],"doc":"The atom types for which the atomic dipole will be provided. If not set, all types will be selected.","repeat":false,"sub_fields":{},"sub_variants":{}},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{},"doc":"The type of the fitting. See explanation below. \\n\\n- `ener`: Fit an energy model (potential energy surface).\\n\\n- `dos` : Fit a density of states model. The total density of states / site-projected density of states labels should be provided by `dos.npy` or `atom_dos.npy` in each data system. The file has number of frames lines and number of energy grid columns (times number of atoms in `atom_dos.npy`). See `loss` parameter. \\n\\n- `dipole`: Fit an atomic dipole model. Global dipole labels or atomic dipole labels for all the selected atoms (see `sel_type`) should be provided by `dipole.npy` in each data system. The file either has number of frames lines and 3 times of number of selected atoms columns, or has number of frames lines and 3 columns. See `loss` parameter.\\n\\n- `polar`: Fit an atomic polarizability model. Global polarizazbility labels or atomic polarizability labels for all the selected atoms (see `sel_type`) should be provided by `polarizability.npy` in each data system. The file eith has number of frames lines and 9 times of number of selected atoms columns, or has number of frames lines and 9 columns. See `loss` parameter.\\n\\n"}}}},"sub_variants":{}},"multi":{"object":"Argument","name":"multi","type":["dict"],"optional":false,"alias":[],"doc":"Multiple-task model.","repeat":false,"sub_fields":{"descriptor":{"object":"Argument","name":"descriptor","type":["dict"],"optional":false,"alias":[],"doc":"The descriptor of atomic environment. See model[standard]/descriptor for details.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"hybrid":{"object":"Argument","name":"hybrid","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"list":{"object":"Argument","name":"list","type":["list"],"optional":false,"alias":[],"doc":"A list of descriptor definitions","repeat":true,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}},"fitting_net_dict":{"object":"Argument","name":"fitting_net_dict","type":["dict"],"optional":false,"alias":[],"doc":"The dictionary of multiple fitting nets in multi-task mode. Each fitting_net_dict[fitting_key] is the single definition of fitting of physical properties with user-defined name `fitting_key`.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"frozen":{"object":"Argument","name":"frozen","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"model_file":{"object":"Argument","name":"model_file","type":["str"],"optional":false,"alias":[],"doc":"Path to the frozen model file.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{},"doc":""}}}},"sub_variants":{}},"linear_ener":{"object":"Argument","name":"linear_ener","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"models":{"object":"Argument","name":"models","type":["list","dict"],"optional":false,"alias":[],"doc":"The sub-models.","repeat":true,"sub_fields":{"type_map":{"object":"Argument","name":"type_map","type":["list"],"optional":true,"alias":[],"doc":"A list of strings. Give the name to each type of atoms. It is noted that the number of atom type of training system must be less than 128 in a GPU environment. If not given, type.raw in each system should use the same type indexes, and type_map.raw will take no effect.","repeat":false,"sub_fields":{},"sub_variants":{}},"data_stat_nbatch":{"object":"Argument","name":"data_stat_nbatch","type":["int"],"optional":true,"alias":[],"doc":"The model determines the normalization from the statistics of the data. This key specifies the number of `frames` in each `system` used for statistics.","repeat":false,"sub_fields":{},"sub_variants":{},"default":10},"data_stat_protect":{"object":"Argument","name":"data_stat_protect","type":["float"],"optional":true,"alias":[],"doc":"Protect parameter for atomic energy regression.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.01},"data_bias_nsample":{"object":"Argument","name":"data_bias_nsample","type":["int"],"optional":true,"alias":[],"doc":"The number of training samples in a system to compute and change the energy bias.","repeat":false,"sub_fields":{},"sub_variants":{},"default":10},"use_srtab":{"object":"Argument","name":"use_srtab","type":["str"],"optional":true,"alias":[],"doc":"The table for the short-range pairwise interaction added on top of DP. The table is a text data file with (N_t + 1) * N_t / 2 + 1 columes. The first colume is the distance between atoms. The second to the last columes are energies for pairs of certain types. For example we have two atom types, 0 and 1. The columes from 2nd to 4th are for 0-0, 0-1 and 1-1 correspondingly.","repeat":false,"sub_fields":{},"sub_variants":{}},"smin_alpha":{"object":"Argument","name":"smin_alpha","type":["float"],"optional":true,"alias":[],"doc":"The short-range tabulated interaction will be swithed according to the distance of the nearest neighbor. This distance is calculated by softmin. This parameter is the decaying parameter in the softmin. It is only required when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{}},"sw_rmin":{"object":"Argument","name":"sw_rmin","type":["float"],"optional":true,"alias":[],"doc":"The lower boundary of the interpolation between short-range tabulated interaction and DP. It is only required when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{}},"sw_rmax":{"object":"Argument","name":"sw_rmax","type":["float"],"optional":true,"alias":[],"doc":"The upper boundary of the interpolation between short-range tabulated interaction and DP. It is only required when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{}},"srtab_add_bias":{"object":"Argument","name":"srtab_add_bias","type":["bool"],"optional":true,"alias":[],"doc":"Whether add energy bias from the statistics of the data to short-range tabulated atomic energy. It only takes effect when `use_srtab` is provided.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"type_embedding":{"object":"Argument","name":"type_embedding","type":["dict"],"optional":true,"alias":[],"doc":"The type embedding.","repeat":false,"sub_fields":{"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[8]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{},"default":null}},"sub_variants":{}},"modifier":{"object":"Argument","name":"modifier","type":["dict"],"optional":true,"alias":[],"doc":"The modifier of model output.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"dipole_charge":{"object":"Argument","name":"dipole_charge","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"model_name":{"object":"Argument","name":"model_name","type":["str"],"optional":false,"alias":[],"doc":"The name of the frozen dipole model file.","repeat":false,"sub_fields":{},"sub_variants":{}},"model_charge_map":{"object":"Argument","name":"model_charge_map","type":["list"],"optional":false,"alias":[],"doc":"The charge of the WFCC. The list length should be the same as the `sel_type <model/fitting_net[dipole]/sel_type_>`_. ","repeat":false,"sub_fields":{},"sub_variants":{}},"sys_charge_map":{"object":"Argument","name":"sys_charge_map","type":["list"],"optional":false,"alias":[],"doc":"The charge of real atoms. The list length should be the same as the `type_map <model/type_map_>`_","repeat":false,"sub_fields":{},"sub_variants":{}},"ewald_beta":{"object":"Argument","name":"ewald_beta","type":["float"],"optional":true,"alias":[],"doc":"The splitting parameter of Ewald sum. Unit is A^-1","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.4},"ewald_h":{"object":"Argument","name":"ewald_h","type":["float"],"optional":true,"alias":[],"doc":"The grid spacing of the FFT grid. Unit is A","repeat":false,"sub_fields":{},"sub_variants":{},"default":1}},"sub_variants":{}}},"choice_alias":{},"doc":"The type of modifier. See explanation below.\\n\\n-`dipole_charge`: Use WFCC to model the electronic structure of the system. Correct the long-range interaction"}}},"compress":{"object":"Argument","name":"compress","type":["dict"],"optional":true,"alias":[],"doc":"Model compression configurations","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":true,"default_tag":"se_e2_a","choice_dict":{"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"model_file":{"object":"Argument","name":"model_file","type":["str"],"optional":false,"alias":[],"doc":"The input model file, which will be compressed by the DeePMD-kit.","repeat":false,"sub_fields":{},"sub_variants":{}},"table_config":{"object":"Argument","name":"table_config","type":["list"],"optional":false,"alias":[],"doc":"The arguments of model compression, including extrapolate(scale of model extrapolation), stride(uniform stride of tabulation\'s first and second table), and frequency(frequency of tabulation overflow check).","repeat":false,"sub_fields":{},"sub_variants":{}},"min_nbor_dist":{"object":"Argument","name":"min_nbor_dist","type":["float"],"optional":false,"alias":[],"doc":"The nearest distance between neighbor atoms saved in the frozen model.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a"},"doc":"The type of model compression, which should be consistent with the descriptor type."}}},"spin":{"object":"Argument","name":"spin","type":["dict"],"optional":true,"alias":[],"doc":"The settings for systems with spin.","repeat":false,"sub_fields":{"use_spin":{"object":"Argument","name":"use_spin","type":["list"],"optional":false,"alias":[],"doc":"Whether to use atomic spin model for each atom type","repeat":false,"sub_fields":{},"sub_variants":{}},"spin_norm":{"object":"Argument","name":"spin_norm","type":["list"],"optional":false,"alias":[],"doc":"The magnitude of atomic spin for each atom type with spin","repeat":false,"sub_fields":{},"sub_variants":{}},"virtual_len":{"object":"Argument","name":"virtual_len","type":["list"],"optional":false,"alias":[],"doc":"The distance between virtual atom representing spin and its corresponding real atom for each atom type with spin","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":true,"default_tag":"standard","choice_dict":{"standard":{"object":"Argument","name":"standard","type":["dict"],"optional":false,"alias":[],"doc":"Stardard model, which contains a descriptor and a fitting.","repeat":false,"sub_fields":{"descriptor":{"object":"Argument","name":"descriptor","type":["dict"],"optional":false,"alias":[],"doc":"The descriptor of atomic environment.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"hybrid":{"object":"Argument","name":"hybrid","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"list":{"object":"Argument","name":"list","type":["list"],"optional":false,"alias":[],"doc":"A list of descriptor definitions","repeat":true,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}},"fitting_net":{"object":"Argument","name":"fitting_net","type":["dict"],"optional":false,"alias":[],"doc":"The fitting of physical properties.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":true,"default_tag":"ener","choice_dict":{"ener":{"object":"Argument","name":"ener","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"numb_fparam":{"object":"Argument","name":"numb_fparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the frame parameter. If set to >0, file `fparam.npy` should be included to provided the input fparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the atomic parameter. If set to >0, file `aparam.npy` should be included to provided the input aparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":["n_neuron"],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"trainable":{"object":"Argument","name":"trainable","type":["list","bool"],"optional":true,"alias":[],"doc":"Whether the parameters in the fitting net are trainable. This option can be\\n\\n- bool: True if all parameters of the fitting net are trainable, False otherwise.\\n\\n- list of bool: Specifies if each layer is trainable. Since the fitting net is composed by hidden layers followed by a output layer, the length of tihs list should be equal to len(`neuron`)+1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"rcond":{"object":"Argument","name":"rcond","type":["NoneType","float"],"optional":true,"alias":[],"doc":"The condition number used to determine the inital energy shift for each type of atoms. See `rcond` in :py:meth:`numpy.linalg.lstsq` for more details.","repeat":false,"sub_fields":{},"sub_variants":{},"default":null},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}},"atom_ener":{"object":"Argument","name":"atom_ener","type":["list"],"optional":true,"alias":[],"doc":"Specify the atomic energy in vacuum for each type","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"layer_name":{"object":"Argument","name":"layer_name","type":["list"],"optional":true,"alias":[],"doc":"The name of the each layer. The length of this list should be equal to n_neuron + 1. If two layers, either in the same fitting or different fittings, have the same name, they will share the same neural network parameters. The shape of these layers should be the same. If null is given for a layer, parameters will not be shared.","repeat":false,"sub_fields":{},"sub_variants":{}},"use_aparam_as_mask":{"object":"Argument","name":"use_aparam_as_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use the aparam as a mask in input.If True, the aparam will not be used in fitting net for embedding.When descrpt is se_a_mask, the aparam will be used as a mask to indicate the input atom is real/virtual. And use_aparam_as_mask should be set to True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"dos":{"object":"Argument","name":"dos","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"numb_fparam":{"object":"Argument","name":"numb_fparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the frame parameter. If set to >0, file `fparam.npy` should be included to provided the input fparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"The dimension of the atomic parameter. If set to >0, file `aparam.npy` should be included to provided the input aparams.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"float64"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"trainable":{"object":"Argument","name":"trainable","type":["list","bool"],"optional":true,"alias":[],"doc":"Whether the parameters in the fitting net are trainable. This option can be\\n\\n- bool: True if all parameters of the fitting net are trainable, False otherwise.\\n\\n- list of bool: Specifies if each layer is trainable. Since the fitting net is composed by hidden layers followed by a output layer, the length of tihs list should be equal to len(`neuron`)+1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"rcond":{"object":"Argument","name":"rcond","type":["NoneType","float"],"optional":true,"alias":[],"doc":"The condition number used to determine the inital energy shift for each type of atoms. See `rcond` in :py:meth:`numpy.linalg.lstsq` for more details.","repeat":false,"sub_fields":{},"sub_variants":{},"default":null},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}},"numb_dos":{"object":"Argument","name":"numb_dos","type":["int"],"optional":true,"alias":[],"doc":"The number of gridpoints on which the DOS is evaluated (NEDOS in VASP)","repeat":false,"sub_fields":{},"sub_variants":{},"default":300}},"sub_variants":{}},"polar":{"object":"Argument","name":"polar","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":["n_neuron"],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"fit_diag":{"object":"Argument","name":"fit_diag","type":["bool"],"optional":true,"alias":[],"doc":"Fit the diagonal part of the rotational invariant polarizability matrix, which will be converted to normal polarizability matrix by contracting with the rotation matrix.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"scale":{"object":"Argument","name":"scale","type":["list","float"],"optional":true,"alias":[],"doc":"The output of the fitting net (polarizability matrix) will be scaled by ``scale``","repeat":false,"sub_fields":{},"sub_variants":{},"default":1},"shift_diag":{"object":"Argument","name":"shift_diag","type":["bool"],"optional":true,"alias":[],"doc":"Whether to shift the diagonal of polar, which is beneficial to training. Default is true.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"sel_type":{"object":"Argument","name":"sel_type","type":["list","int","NoneType"],"optional":true,"alias":["pol_type"],"doc":"The atom types for which the atomic polarizability will be provided. If not set, all types will be selected.","repeat":false,"sub_fields":{},"sub_variants":{}},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"dipole":{"object":"Argument","name":"dipole","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":["n_neuron"],"doc":"The number of neurons in each hidden layers of the fitting net. When two hidden layers are of the same size, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[120,120,120]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the fitting net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the fitting net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"sel_type":{"object":"Argument","name":"sel_type","type":["list","int","NoneType"],"optional":true,"alias":["dipole_type"],"doc":"The atom types for which the atomic dipole will be provided. If not set, all types will be selected.","repeat":false,"sub_fields":{},"sub_variants":{}},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization of the fitting net","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{},"doc":"The type of the fitting. See explanation below. \\n\\n- `ener`: Fit an energy model (potential energy surface).\\n\\n- `dos` : Fit a density of states model. The total density of states / site-projected density of states labels should be provided by `dos.npy` or `atom_dos.npy` in each data system. The file has number of frames lines and number of energy grid columns (times number of atoms in `atom_dos.npy`). See `loss` parameter. \\n\\n- `dipole`: Fit an atomic dipole model. Global dipole labels or atomic dipole labels for all the selected atoms (see `sel_type`) should be provided by `dipole.npy` in each data system. The file either has number of frames lines and 3 times of number of selected atoms columns, or has number of frames lines and 3 columns. See `loss` parameter.\\n\\n- `polar`: Fit an atomic polarizability model. Global polarizazbility labels or atomic polarizability labels for all the selected atoms (see `sel_type`) should be provided by `polarizability.npy` in each data system. The file eith has number of frames lines and 9 times of number of selected atoms columns, or has number of frames lines and 9 columns. See `loss` parameter.\\n\\n"}}}},"sub_variants":{}},"multi":{"object":"Argument","name":"multi","type":["dict"],"optional":false,"alias":[],"doc":"Multiple-task model.","repeat":false,"sub_fields":{"descriptor":{"object":"Argument","name":"descriptor","type":["dict"],"optional":false,"alias":[],"doc":"The descriptor of atomic environment. See model[standard]/descriptor for details.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"hybrid":{"object":"Argument","name":"hybrid","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"list":{"object":"Argument","name":"list","type":["list"],"optional":false,"alias":[],"doc":"A list of descriptor definitions","repeat":true,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":false,"default_tag":"","choice_dict":{"loc_frame":{"object":"Argument","name":"loc_frame","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel_a":{"object":"Argument","name":"sel_a","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_a[i]` gives the selected number of type-i neighbors. The full relative coordinates of the neighbors are used by the descriptor.","repeat":false,"sub_fields":{},"sub_variants":{}},"sel_r":{"object":"Argument","name":"sel_r","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length of the list should be the same as the number of atom types in the system. `sel_r[i]` gives the selected number of type-i neighbors. Only relative distance of the neighbors are used by the descriptor. sel_a[i] + sel_r[i] is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{}},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius. The default value is 6.0","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"axis_rule":{"object":"Argument","name":"axis_rule","type":["list"],"optional":false,"alias":[],"doc":"A list of integers. The length should be 6 times of the number of types. \\n\\n- axis_rule[i*6+0]: class of the atom defining the first axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+1]: type of the atom defining the first axis of type-i atom.\\n\\n- axis_rule[i*6+2]: index of the axis atom defining the first axis. Note that the neighbors with the same class and type are sorted according to their relative distance.\\n\\n- axis_rule[i*6+3]: class of the atom defining the second axis of type-i atom. 0 for neighbors with full coordinates and 1 for neighbors only with relative distance.\\n\\n- axis_rule[i*6+4]: type of the atom defining the second axis of type-i atom.\\n\\n- axis_rule[i*6+5]: index of the axis atom defining the second axis. Note that the neighbors with the same class and type are sorted according to their relative distance.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"se_e2_a":{"object":"Argument","name":"se_e2_a","type":["dict"],"optional":false,"alias":["se_a"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_e3":{"object":"Argument","name":"se_e3","type":["dict"],"optional":false,"alias":["se_at","se_a_3be","se_t"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_tpe":{"object":"Argument","name":"se_a_tpe","type":["dict"],"optional":false,"alias":["se_a_ebd"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_nchanl":{"object":"Argument","name":"type_nchanl","type":["int"],"optional":true,"alias":[],"doc":"number of channels for type embedding","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"type_nlayer":{"object":"Argument","name":"type_nlayer","type":["int"],"optional":true,"alias":[],"doc":"number of hidden layers of type embedding net","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"numb_aparam":{"object":"Argument","name":"numb_aparam","type":["int"],"optional":true,"alias":[],"doc":"dimension of atomic parameter. if set to a value > 0, the atomic parameters are embedded.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"se_e2_r":{"object":"Argument","name":"se_e2_r","type":["dict"],"optional":false,"alias":["se_r"],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net are trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}}},"sub_variants":{}},"se_atten":{"object":"Argument","name":"se_atten","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"stripped_type_embedding":{"object":"Argument","name":"stripped_type_embedding","type":["bool"],"optional":true,"alias":[],"doc":"Whether to strip the type embedding into a separated embedding network. Setting it to `False` will fall back to the previous version of `se_atten` which is non-compressible.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"smooth_type_embdding":{"object":"Argument","name":"smooth_type_embdding","type":["bool"],"optional":true,"alias":[],"doc":"When using stripped type embedding, whether to dot smooth factor on the network output of type embedding to keep the network smooth, instead of setting `set_davg_zero` to be True.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":true}},"sub_variants":{}},"se_atten_v2":{"object":"Argument","name":"se_atten_v2","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","int","str"],"optional":true,"alias":[],"doc":"This parameter set the number of selected neighbors. Note that this parameter is a little different from that in other descriptors. Instead of separating each type of atoms, only the summation matters. And this number is highly related with the efficiency, thus one should not make it too large. Usually 200 or less is enough, far away from the GPU limitation 4096. It can be:\\n\\n    - `int`. The maximum number of neighbor atoms to be considered. We recommend it to be less than 200. \\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. Only the summation of `sel[i]` matters, and it is recommended to be less than 200.    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"rcut":{"object":"Argument","name":"rcut","type":["float"],"optional":true,"alias":[],"doc":"The cut-off radius.","repeat":false,"sub_fields":{},"sub_variants":{},"default":6},"rcut_smth":{"object":"Argument","name":"rcut_smth","type":["float"],"optional":true,"alias":[],"doc":"Where to start smoothing. For example the 1/r term is smoothed from `rcut` to `rcut_smth`","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.5},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"attn":{"object":"Argument","name":"attn","type":["int"],"optional":true,"alias":[],"doc":"The length of hidden vectors in attention layers","repeat":false,"sub_fields":{},"sub_variants":{},"default":128},"attn_layer":{"object":"Argument","name":"attn_layer","type":["int"],"optional":true,"alias":[],"doc":"The number of attention layers. Note that model compression of `se_atten` is only enabled when attn_layer==0 and stripped_type_embedding is True","repeat":false,"sub_fields":{},"sub_variants":{},"default":2},"attn_dotr":{"object":"Argument","name":"attn_dotr","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do dot product with the normalized relative coordinates","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"attn_mask":{"object":"Argument","name":"attn_mask","type":["bool"],"optional":true,"alias":[],"doc":"Whether to do mask on the diagonal in the attention matrix","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"set_davg_zero":{"object":"Argument","name":"set_davg_zero","type":["bool"],"optional":true,"alias":[],"doc":"Set the normalization average to zero. This option should be set when `se_atten` descriptor or `atom_ener` in the energy fitting is used","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"se_a_mask":{"object":"Argument","name":"se_a_mask","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"sel":{"object":"Argument","name":"sel","type":["list","str"],"optional":true,"alias":[],"doc":"This parameter sets the number of selected neighbors for each type of atom. It can be:\\n\\n    - `List[int]`. The length of the list should be the same as the number of atom types in the system. `sel[i]` gives the selected number of type-i neighbors. `sel[i]` is recommended to be larger than the maximally possible number of type-i neighbors in the cut-off radius. It is noted that the total sel value must be less than 4096 in a GPU environment.\\n\\n    - `str`. Can be \\"auto:factor\\" or \\"auto\\". \\"factor\\" is a float number larger than 1. This option will automatically determine the `sel`. In detail it counts the maximal number of neighbors with in the cutoff radius for each type of neighbor, then multiply the maximum by the \\"factor\\". Finally the number is wraped up to 4 divisible. The option \\"auto\\" is equivalent to \\"auto:1.1\\".","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"neuron":{"object":"Argument","name":"neuron","type":["list"],"optional":true,"alias":[],"doc":"Number of neurons in each hidden layers of the embedding net. When two layers are of the same size or one layer is twice as large as the previous layer, a skip connection is built.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[10,20,40]},"axis_neuron":{"object":"Argument","name":"axis_neuron","type":["int"],"optional":true,"alias":["n_axis_neuron"],"doc":"Size of the submatrix of G (embedding matrix).","repeat":false,"sub_fields":{},"sub_variants":{},"default":4},"activation_function":{"object":"Argument","name":"activation_function","type":["str"],"optional":true,"alias":[],"doc":"The activation function in the embedding net. Supported activation functions are \\"relu\\", \\"relu6\\", \\"softplus\\", \\"sigmoid\\", \\"tanh\\", \\"gelu\\", \\"gelu_tf\\", \\"None\\", \\"none\\". Note that \\"gelu\\" denotes the custom operator version, and \\"gelu_tf\\" denotes the TF standard version. If you set \\"None\\" or \\"none\\" here, no activation function will be used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"tanh"},"resnet_dt":{"object":"Argument","name":"resnet_dt","type":["bool"],"optional":true,"alias":[],"doc":"Whether to use a \\"Timestep\\" in the skip connection","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"type_one_side":{"object":"Argument","name":"type_one_side","type":["bool"],"optional":true,"alias":[],"doc":"If true, the embedding network parameters vary by types of neighbor atoms only, so there will be $N_\\\\text{types}$ sets of embedding network parameters. Otherwise, the embedding network parameters vary by types of centric atoms and types of neighbor atoms, so there will be $N_\\\\text{types}^2$ sets of embedding network parameters.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"exclude_types":{"object":"Argument","name":"exclude_types","type":["list"],"optional":true,"alias":[],"doc":"The excluded pairs of types which have no interaction with each other. For example, `[[0, 1]]` means no interaction between type 0 and type 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":[]},"precision":{"object":"Argument","name":"precision","type":["str"],"optional":true,"alias":[],"doc":"The precision of the embedding net parameters, supported options are \\"default\\", \\"float16\\", \\"float32\\", \\"float64\\", \\"bfloat16\\". Default follows the interface precision.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"default"},"trainable":{"object":"Argument","name":"trainable","type":["bool"],"optional":true,"alias":[],"doc":"If the parameters in the embedding net is trainable","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"Random seed for parameter initialization","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{"se_a":"se_e2_a","se_at":"se_e3","se_a_3be":"se_e3","se_t":"se_e3","se_a_ebd":"se_a_tpe","se_r":"se_e2_r"},"doc":"The type of the descritpor. See explanation below. \\n\\n- `loc_frame`: Defines a local frame at each atom, and the compute the descriptor as local coordinates under this frame.\\n\\n- `se_e2_a`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor.\\n\\n- `se_e2_r`: Used by the smooth edition of Deep Potential. Only the distance between atoms is used to construct the descriptor.\\n\\n- `se_e3`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Three-body embedding will be used by this descriptor.\\n\\n- `se_a_tpe`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Type embedding will be used by this descriptor.\\n\\n- `se_atten`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism will be used by this descriptor.\\n\\n- `se_atten_v2`: Used by the smooth edition of Deep Potential. The full relative coordinates are used to construct the descriptor. Attention mechanism with new modifications will be used by this descriptor.\\n\\n- `se_a_mask`: Used by the smooth edition of Deep Potential. It can accept a variable number of atoms in a frame (Non-PBC system). *aparam* are required as an indicator matrix for the real/virtual sign of input atoms. \\n\\n- `hybrid`: Concatenate of a list of descriptors as a new descriptor."}}},"fitting_net_dict":{"object":"Argument","name":"fitting_net_dict","type":["dict"],"optional":false,"alias":[],"doc":"The dictionary of multiple fitting nets in multi-task mode. Each fitting_net_dict[fitting_key] is the single definition of fitting of physical properties with user-defined name `fitting_key`.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"frozen":{"object":"Argument","name":"frozen","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"model_file":{"object":"Argument","name":"model_file","type":["str"],"optional":false,"alias":[],"doc":"Path to the frozen model file.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{},"doc":""}}},"weights":{"object":"Argument","name":"weights","type":["list","str"],"optional":false,"alias":[],"doc":"If the type is list of float, a list of weights for each model. If \\"mean\\", the weights are set to be 1 / len(models). If \\"sum\\", the weights are set to be 1.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{},"doc":""}}},{"object":"Argument","name":"learning_rate","type":["dict"],"optional":true,"alias":[],"doc":"The definitio of learning rate","repeat":false,"sub_fields":{"scale_by_worker":{"object":"Argument","name":"scale_by_worker","type":["str"],"optional":true,"alias":[],"doc":"When parallel training or batch size scaled, how to alter learning rate. Valid values are `linear`(default), `sqrt` or `none`.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"linear"}},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":true,"default_tag":"exp","choice_dict":{"exp":{"object":"Argument","name":"exp","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"start_lr":{"object":"Argument","name":"start_lr","type":["float"],"optional":true,"alias":[],"doc":"The learning rate at the start of the training.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.001},"stop_lr":{"object":"Argument","name":"stop_lr","type":["float"],"optional":true,"alias":[],"doc":"The desired learning rate at the end of the training.","repeat":false,"sub_fields":{},"sub_variants":{},"default":1e-8},"decay_steps":{"object":"Argument","name":"decay_steps","type":["int"],"optional":true,"alias":[],"doc":"The learning rate is decaying every this number of training steps.","repeat":false,"sub_fields":{},"sub_variants":{},"default":5000}},"sub_variants":{}}},"choice_alias":{},"doc":"The type of the learning rate."}}},{"object":"Argument","name":"loss","type":["dict"],"optional":true,"alias":[],"doc":"The definition of loss function. The loss type should be set to `tensor`, `ener` or left unset.","repeat":false,"sub_fields":{},"sub_variants":{"type":{"object":"Variant","flag_name":"type","optional":true,"default_tag":"ener","choice_dict":{"ener":{"object":"Argument","name":"ener","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"start_pref_e":{"object":"Argument","name":"start_pref_e","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of energy loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the energy label should be provided by file energy.npy in each data system. If both start_pref_e and limit_pref_e are set to 0, then the energy will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.02},"limit_pref_e":{"object":"Argument","name":"limit_pref_e","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of energy loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":1},"start_pref_f":{"object":"Argument","name":"start_pref_f","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of force loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the force label should be provided by file force.npy in each data system. If both start_pref_f and limit_pref_f are set to 0, then the force will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":1000},"limit_pref_f":{"object":"Argument","name":"limit_pref_f","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of force loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":1},"start_pref_v":{"object":"Argument","name":"start_pref_v","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of virial loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the virial label should be provided by file virial.npy in each data system. If both start_pref_v and limit_pref_v are set to 0, then the virial will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"limit_pref_v":{"object":"Argument","name":"limit_pref_v","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of virial loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"start_pref_ae":{"object":"Argument","name":"start_pref_ae","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of atomic energy loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the atom_ener label should be provided by file atom_ener.npy in each data system. If both start_pref_ae and limit_pref_ae are set to 0, then the atomic energy will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"limit_pref_ae":{"object":"Argument","name":"limit_pref_ae","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of atomic energy loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"start_pref_pf":{"object":"Argument","name":"start_pref_pf","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of atomic prefactor force loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the atom_pref label should be provided by file atom_pref.npy in each data system. If both start_pref_pf and limit_pref_pf are set to 0, then the atomic prefactor force will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"limit_pref_pf":{"object":"Argument","name":"limit_pref_pf","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of atomic prefactor force loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"relative_f":{"object":"Argument","name":"relative_f","type":["NoneType","float"],"optional":true,"alias":[],"doc":"If provided, relative force error will be used in the loss. The difference of force will be normalized by the magnitude of the force in the label with a shift given by `relative_f`, i.e. DF_i / ( || F || + relative_f ) with DF denoting the difference between prediction and label and || F || denoting the L2 norm of the label.","repeat":false,"sub_fields":{},"sub_variants":{}},"enable_atom_ener_coeff":{"object":"Argument","name":"enable_atom_ener_coeff","type":["bool"],"optional":true,"alias":[],"doc":"If true, the energy will be computed as \\\\sum_i c_i E_i. c_i should be provided by file atom_ener_coeff.npy in each data system, otherwise it\'s 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"start_pref_gf":{"object":"Argument","name":"start_pref_gf","type":["float"],"optional":true,"alias":[],"doc":"The prefactor of generalized force loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the drdq label should be provided by file drdq.npy in each data system. If both start_pref_gf and limit_pref_gf are set to 0, then the generalized force will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"limit_pref_gf":{"object":"Argument","name":"limit_pref_gf","type":["float"],"optional":true,"alias":[],"doc":"The prefactor of generalized force loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"numb_generalized_coord":{"object":"Argument","name":"numb_generalized_coord","type":["int"],"optional":true,"alias":[],"doc":"The dimension of generalized coordinates. Required when generalized force loss is used.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"ener_spin":{"object":"Argument","name":"ener_spin","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"start_pref_e":{"object":"Argument","name":"start_pref_e","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of energy loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the energy label should be provided by file energy.npy in each data system. If both start_pref_energy and limit_pref_energy are set to 0, then the energy will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0.02},"limit_pref_e":{"object":"Argument","name":"limit_pref_e","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of energy loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":1},"start_pref_fr":{"object":"Argument","name":"start_pref_fr","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of force_real_atom loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the force_real_atom label should be provided by file force_real_atom.npy in each data system. If both start_pref_force_real_atom and limit_pref_force_real_atom are set to 0, then the force_real_atom will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":1000},"limit_pref_fr":{"object":"Argument","name":"limit_pref_fr","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of force_real_atom loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":1},"start_pref_fm":{"object":"Argument","name":"start_pref_fm","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of force_magnetic loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the force_magnetic label should be provided by file force_magnetic.npy in each data system. If both start_pref_force_magnetic and limit_pref_force_magnetic are set to 0, then the force_magnetic will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":10000},"limit_pref_fm":{"object":"Argument","name":"limit_pref_fm","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of force_magnetic loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":10},"start_pref_v":{"object":"Argument","name":"start_pref_v","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of virial loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the virial label should be provided by file virial.npy in each data system. If both start_pref_virial and limit_pref_virial are set to 0, then the virial will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"limit_pref_v":{"object":"Argument","name":"limit_pref_v","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of virial loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"start_pref_ae":{"object":"Argument","name":"start_pref_ae","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of atom_ener loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the atom_ener label should be provided by file atom_ener.npy in each data system. If both start_pref_atom_ener and limit_pref_atom_ener are set to 0, then the atom_ener will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"limit_pref_ae":{"object":"Argument","name":"limit_pref_ae","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of atom_ener loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"start_pref_pf":{"object":"Argument","name":"start_pref_pf","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of atom_pref loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the atom_pref label should be provided by file atom_pref.npy in each data system. If both start_pref_atom_pref and limit_pref_atom_pref are set to 0, then the atom_pref will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"limit_pref_pf":{"object":"Argument","name":"limit_pref_pf","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of atom_pref loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"relative_f":{"object":"Argument","name":"relative_f","type":["NoneType","float"],"optional":true,"alias":[],"doc":"If provided, relative force error will be used in the loss. The difference of force will be normalized by the magnitude of the force in the label with a shift given by `relative_f`, i.e. DF_i / ( || F || + relative_f ) with DF denoting the difference between prediction and label and || F || denoting the L2 norm of the label.","repeat":false,"sub_fields":{},"sub_variants":{}},"enable_atom_ener_coeff":{"object":"Argument","name":"enable_atom_ener_coeff","type":["bool"],"optional":true,"alias":[],"doc":"If true, the energy will be computed as \\\\sum_i c_i E_i. c_i should be provided by file atom_ener_coeff.npy in each data system, otherwise it\'s 1.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false}},"sub_variants":{}},"dos":{"object":"Argument","name":"dos","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"start_pref_dos":{"object":"Argument","name":"start_pref_dos","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of Density of State (DOS) loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the Density of State (DOS) label should be provided by file Density of State (DOS).npy in each data system. If both start_pref_Density of State (DOS) and limit_pref_Density of State (DOS) are set to 0, then the Density of State (DOS) will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"limit_pref_dos":{"object":"Argument","name":"limit_pref_dos","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of Density of State (DOS) loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"start_pref_cdf":{"object":"Argument","name":"start_pref_cdf","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of Cumulative Distribution Function (cumulative intergral of DOS) loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the Cumulative Distribution Function (cumulative intergral of DOS) label should be provided by file Cumulative Distribution Function (cumulative intergral of DOS).npy in each data system. If both start_pref_Cumulative Distribution Function (cumulative intergral of DOS) and limit_pref_Cumulative Distribution Function (cumulative intergral of DOS) are set to 0, then the Cumulative Distribution Function (cumulative intergral of DOS) will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"limit_pref_cdf":{"object":"Argument","name":"limit_pref_cdf","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of Cumulative Distribution Function (cumulative intergral of DOS) loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"start_pref_ados":{"object":"Argument","name":"start_pref_ados","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of atomic DOS (site-projected DOS) loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the atomic DOS (site-projected DOS) label should be provided by file atomic DOS (site-projected DOS).npy in each data system. If both start_pref_atomic DOS (site-projected DOS) and limit_pref_atomic DOS (site-projected DOS) are set to 0, then the atomic DOS (site-projected DOS) will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":1},"limit_pref_ados":{"object":"Argument","name":"limit_pref_ados","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of atomic DOS (site-projected DOS) loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":1},"start_pref_acdf":{"object":"Argument","name":"start_pref_acdf","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of Cumulative integral of atomic DOS loss at the start of the training. Should be larger than or equal to 0. If set to none-zero value, the Cumulative integral of atomic DOS label should be provided by file Cumulative integral of atomic DOS.npy in each data system. If both start_pref_Cumulative integral of atomic DOS and limit_pref_Cumulative integral of atomic DOS are set to 0, then the Cumulative integral of atomic DOS will be ignored.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0},"limit_pref_acdf":{"object":"Argument","name":"limit_pref_acdf","type":["int","float"],"optional":true,"alias":[],"doc":"The prefactor of Cumulative integral of atomic DOS loss at the limit of the training, Should be larger than or equal to 0. i.e. the training step goes to infinity.","repeat":false,"sub_fields":{},"sub_variants":{},"default":0}},"sub_variants":{}},"tensor":{"object":"Argument","name":"tensor","type":["dict"],"optional":false,"alias":[],"doc":"","repeat":false,"sub_fields":{"pref":{"object":"Argument","name":"pref","type":["int","float"],"optional":false,"alias":[],"doc":"The prefactor of the weight of global loss. It should be larger than or equal to 0. If controls the weight of loss corresponding to global label, i.e. \'polarizability.npy` or `dipole.npy`, whose shape should be #frames x [9 or 3]. If it\'s larger than 0.0, this npy should be included.","repeat":false,"sub_fields":{},"sub_variants":{}},"pref_atomic":{"object":"Argument","name":"pref_atomic","type":["int","float"],"optional":false,"alias":[],"doc":"The prefactor of the weight of atomic loss. It should be larger than or equal to 0. If controls the weight of loss corresponding to atomic label, i.e. `atomic_polarizability.npy` or `atomic_dipole.npy`, whose shape should be #frames x ([9 or 3] x #selected atoms). If it\'s larger than 0.0, this npy should be included. Both `pref` and `pref_atomic` should be provided, and either can be set to 0.0.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}},"choice_alias":{},"doc":"The type of the loss. When the fitting type is `ener`, the loss type should be set to `ener` or left unset. When the fitting type is `dipole` or `polar`, the loss type should be set to `tensor`."}}},{"object":"Argument","name":"training","type":["dict"],"optional":false,"alias":[],"doc":"The training options.","repeat":false,"sub_fields":{"training_data":{"object":"Argument","name":"training_data","type":["dict"],"optional":true,"alias":[],"doc":"Configurations of training data.","repeat":false,"sub_fields":{"systems":{"object":"Argument","name":"systems","type":["list","str"],"optional":false,"alias":[],"doc":"The data systems for training. This key can be provided with a list that specifies the systems, or be provided with a string by which the prefix of all systems are given and the list of the systems is automatically generated.","repeat":false,"sub_fields":{},"sub_variants":{}},"set_prefix":{"object":"Argument","name":"set_prefix","type":["str"],"optional":true,"alias":[],"doc":"The prefix of the sets in the `systems <training/training_data/systems_>`_.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"set"},"batch_size":{"object":"Argument","name":"batch_size","type":["list","int","str"],"optional":true,"alias":[],"doc":"This key can be \\n\\n- list: the length of which is the same as the `systems <training/training_data/systems_>`_. The batch size of each system is given by the elements of the list.\\n\\n- int: all `systems <training/training_data/systems_>`_ use the same batch size.\\n\\n- string \\"auto\\": automatically determines the batch size so that the batch_size times the number of atoms in the system is no less than 32.\\n\\n- string \\"auto:N\\": automatically determines the batch size so that the batch_size times the number of atoms in the system is no less than N.\\n\\n- string \\"mixed:N\\": the batch data will be sampled from all systems and merged into a mixed system with the batch size N. Only support the se_atten descriptor.\\n\\nIf MPI is used, the value should be considered as the batch size per task.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"auto_prob":{"object":"Argument","name":"auto_prob","type":["str"],"optional":true,"alias":["auto_prob_style"],"doc":"Determine the probability of systems automatically. The method is assigned by this key and can be\\n\\n- \\"prob_uniform\\"  : the probability all the systems are equal, namely 1.0/self.get_nsystems()\\n\\n- \\"prob_sys_size\\" : the probability of a system is proportional to the number of batches in the system\\n\\n- \\"prob_sys_size;stt_idx:end_idx:weight;stt_idx:end_idx:weight;...\\" : the list of systems is devided into blocks. A block is specified by `stt_idx:end_idx:weight`, where `stt_idx` is the starting index of the system, `end_idx` is then ending (not including) index of the system, the probabilities of the systems in this block sums up to `weight`, and the relatively probabilities within this block is proportional to the number of batches in the system.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"prob_sys_size"},"sys_probs":{"object":"Argument","name":"sys_probs","type":["list","NoneType"],"optional":true,"alias":["sys_weights"],"doc":"A list of float if specified. Should be of the same length as `systems`, specifying the probability of each system.","repeat":false,"sub_fields":{},"sub_variants":{},"default":null}},"sub_variants":{}},"validation_data":{"object":"Argument","name":"validation_data","type":["NoneType","dict"],"optional":true,"alias":[],"doc":"Configurations of validation data. Similar to that of training data, except that a `numb_btch` argument may be configured","repeat":false,"sub_fields":{"systems":{"object":"Argument","name":"systems","type":["list","str"],"optional":false,"alias":[],"doc":"The data systems for validation. This key can be provided with a list that specifies the systems, or be provided with a string by which the prefix of all systems are given and the list of the systems is automatically generated.","repeat":false,"sub_fields":{},"sub_variants":{}},"set_prefix":{"object":"Argument","name":"set_prefix","type":["str"],"optional":true,"alias":[],"doc":"The prefix of the sets in the `systems <training/validation_data/systems_>`_.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"set"},"batch_size":{"object":"Argument","name":"batch_size","type":["list","int","str"],"optional":true,"alias":[],"doc":"This key can be \\n\\n- list: the length of which is the same as the `systems <training/validation_data/systems_>`_. The batch size of each system is given by the elements of the list.\\n\\n- int: all `systems <training/validation_data/systems_>`_ use the same batch size.\\n\\n- string \\"auto\\": automatically determines the batch size so that the batch_size times the number of atoms in the system is no less than 32.\\n\\n- string \\"auto:N\\": automatically determines the batch size so that the batch_size times the number of atoms in the system is no less than N.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"auto"},"auto_prob":{"object":"Argument","name":"auto_prob","type":["str"],"optional":true,"alias":["auto_prob_style"],"doc":"Determine the probability of systems automatically. The method is assigned by this key and can be\\n\\n- \\"prob_uniform\\"  : the probability all the systems are equal, namely 1.0/self.get_nsystems()\\n\\n- \\"prob_sys_size\\" : the probability of a system is proportional to the number of batches in the system\\n\\n- \\"prob_sys_size;stt_idx:end_idx:weight;stt_idx:end_idx:weight;...\\" : the list of systems is devided into blocks. A block is specified by `stt_idx:end_idx:weight`, where `stt_idx` is the starting index of the system, `end_idx` is then ending (not including) index of the system, the probabilities of the systems in this block sums up to `weight`, and the relatively probabilities within this block is proportional to the number of batches in the system.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"prob_sys_size"},"sys_probs":{"object":"Argument","name":"sys_probs","type":["list","NoneType"],"optional":true,"alias":["sys_weights"],"doc":"A list of float if specified. Should be of the same length as `systems`, specifying the probability of each system.","repeat":false,"sub_fields":{},"sub_variants":{},"default":null},"numb_btch":{"object":"Argument","name":"numb_btch","type":["int"],"optional":true,"alias":["numb_batch"],"doc":"An integer that specifies the number of batches to be sampled for each validation period.","repeat":false,"sub_fields":{},"sub_variants":{},"default":1}},"sub_variants":{},"default":null},"mixed_precision":{"object":"Argument","name":"mixed_precision","type":["dict"],"optional":true,"alias":[],"doc":"Configurations of mixed precision.","repeat":false,"sub_fields":{"output_prec":{"object":"Argument","name":"output_prec","type":["str"],"optional":true,"alias":[],"doc":"The precision for mixed precision params. \\"         \\"The trainable variables precision during the mixed precision training process, \\"         \\"supported options are float32 only currently.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"float32"},"compute_prec":{"object":"Argument","name":"compute_prec","type":["str"],"optional":false,"alias":[],"doc":"The precision for mixed precision compute. \\"         \\"The compute precision during the mixed precision training process, \\"\\"         \\"supported options are float16 and bfloat16 currently.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}},"numb_steps":{"object":"Argument","name":"numb_steps","type":["int"],"optional":false,"alias":["stop_batch"],"doc":"Number of training batch. Each training uses one batch of data.","repeat":false,"sub_fields":{},"sub_variants":{}},"seed":{"object":"Argument","name":"seed","type":["int","NoneType"],"optional":true,"alias":[],"doc":"The random seed for getting frames from the training data set.","repeat":false,"sub_fields":{},"sub_variants":{}},"disp_file":{"object":"Argument","name":"disp_file","type":["str"],"optional":true,"alias":[],"doc":"The file for printing learning curve.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"lcurve.out"},"disp_freq":{"object":"Argument","name":"disp_freq","type":["int"],"optional":true,"alias":[],"doc":"The frequency of printing learning curve.","repeat":false,"sub_fields":{},"sub_variants":{},"default":1000},"save_freq":{"object":"Argument","name":"save_freq","type":["int"],"optional":true,"alias":[],"doc":"The frequency of saving check point.","repeat":false,"sub_fields":{},"sub_variants":{},"default":1000},"save_ckpt":{"object":"Argument","name":"save_ckpt","type":["str"],"optional":true,"alias":[],"doc":"The path prefix of saving check point files.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"model.ckpt"},"disp_training":{"object":"Argument","name":"disp_training","type":["bool"],"optional":true,"alias":[],"doc":"Displaying verbose information during training.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"time_training":{"object":"Argument","name":"time_training","type":["bool"],"optional":true,"alias":[],"doc":"Timing durining training.","repeat":false,"sub_fields":{},"sub_variants":{},"default":true},"profiling":{"object":"Argument","name":"profiling","type":["bool"],"optional":true,"alias":[],"doc":"Profiling during training.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"profiling_file":{"object":"Argument","name":"profiling_file","type":["str"],"optional":true,"alias":[],"doc":"Output file for profiling.","repeat":false,"sub_fields":{},"sub_variants":{},"default":"timeline.json"},"enable_profiler":{"object":"Argument","name":"enable_profiler","type":["bool"],"optional":true,"alias":[],"doc":"Enable TensorFlow Profiler (available in TensorFlow 2.3) to analyze performance. The log will be saved to `tensorboard_log_dir`.","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"tensorboard":{"object":"Argument","name":"tensorboard","type":["bool"],"optional":true,"alias":[],"doc":"Enable tensorboard","repeat":false,"sub_fields":{},"sub_variants":{},"default":false},"tensorboard_log_dir":{"object":"Argument","name":"tensorboard_log_dir","type":["str"],"optional":true,"alias":[],"doc":"The log directory of tensorboard outputs","repeat":false,"sub_fields":{},"sub_variants":{},"default":"log"},"tensorboard_freq":{"object":"Argument","name":"tensorboard_freq","type":["int"],"optional":true,"alias":[],"doc":"The frequency of writing tensorboard events.","repeat":false,"sub_fields":{},"sub_variants":{},"default":1},"data_dict":{"object":"Argument","name":"data_dict","type":["dict"],"optional":true,"alias":[],"doc":"The dictionary of multi DataSystems in multi-task mode. Each data_dict[fitting_key], with user-defined name `fitting_key` in `model/fitting_net_dict`, contains training data and optional validation data definitions.","repeat":false,"sub_fields":{},"sub_variants":{}},"fitting_weight":{"object":"Argument","name":"fitting_weight","type":["dict"],"optional":true,"alias":[],"doc":"Each fitting_weight[fitting_key], with user-defined name `fitting_key` in `model/fitting_net_dict`, is the training weight of fitting net `fitting_key`. Fitting nets with higher weights will be selected with higher probabilities to be trained in one step. Weights will be normalized and minus ones will be ignored. If not set, each fitting net will be equally selected when training.","repeat":false,"sub_fields":{},"sub_variants":{}}},"sub_variants":{}}]')}}]);